const _document = document, _createTextNode = _document.createTextNode.bind(_document), _Object = Object, _Array = Array, _Symbol = Symbol, { iterator: SYMBOL_ITERATOR } = _Symbol, _Boolean = Boolean, _Map = Map, _Node = Node, _console = console, { now: _now } = Date, _requestAnimationFrame = requestAnimationFrame, { assign: _assign, is: _is, keys: _keys, entries: _entries, create: _create } = _Object, { toString: _toString, hasOwnProperty: _hasOwnProperty } = _Object.prototype, { isArray: _isArray, from: _from } = _Array, { splice: _splice, push: _push, indexOf: _indexOf } = _Array.prototype, _undefined = undefined, _null = null, _Infinity = Infinity;

const registry = new _Map();
const define = function (name, desc) {
    const type = _Symbol(name);
    registry.set(type, desc);
    return type;
};

const toArr = (a) => (_isArray(a) ? a : [a]);
const toFrag = (nodes) => nodes.reduce((frag, node) => (frag.appendChild(node), frag), _document.createDocumentFragment());
const isHNode = function isHN(value) {
    return value && isObject(value) && value.isHN;
};
const replaceNodes = function replNodes(ownerNode, oldNodes, newNodes) {
    oldNodes.forEach((oldNode, i) => {
        if (i) {
            ownerNode.removeChild(oldNode);
        }
        else {
            ownerNode.replaceChild(toFrag(newNodes), oldNode);
        }
    });
};
const inherit = function (target, source) {
    target.nodes = source.nodes;
    target.owner = source.owner;
    target.ownNode = source.ownNode;
    target.ctx = source.ctx;
    target.sto = source.sto;
    if (source.desc) {
        target.out = source.out;
    }
    else {
        target.evMap = source.evMap;
    }
};
const supply = function (target, defaults) {
    _keys(defaults).forEach(key => {
        if (!_hasOwnProperty.call(target, key)) {
            target[key] = defaults[key];
        }
    });
};
const isObject = function isObj(value) {
    return typeof value === 'object';
};

const renderCallbacks = new Array();
const renderToDOM = function render(src, options = _create(_null)) {
    const { parent = _document.body, clear, owner, context = createStore(), defaultContext, contextHandlers } = options;
    if (defaultContext) {
        context.setSome(defaultContext);
    }
    if (contextHandlers) {
        context.handleSome(contextHandlers);
    }
    if (options.sync) {
        if (clear) {
            _from(parent.childNodes).forEach(childNode => {
                parent.removeChild(childNode);
            });
        }
        parent.appendChild(toFrag(toNodeArr(src, context, parent, owner)));
    }
    else {
        renderCallbacks.push(() => {
            renderToDOM(src, { parent, owner, clear, context, sync: true });
        });
        if (!willTick) {
            reqTick();
        }
    }
};

const noCmpProps = ['children'];
const patch = function patchEle(element, hNode, curProps, oldProps, curPropKeys) {
    let curProp, oldProp;
    curPropKeys.forEach(key => {
        curProp = curProps[key];
        oldProp = oldProps[key];
        if (noCmpProps.includes(key) || !HUI.cmp(curProp, oldProp)) {
            handleProp(element, hNode, key, curProp, oldProp);
        }
    });
};

const clear = function clr(hNode) {
    const { desc, props } = hNode;
    hNode.active = false;
    if (desc) {
        const { sto, ctx } = hNode;
        try {
            if (hNode.eff) {
                hNode.eff.forEach(effCanceller => {
                    effCanceller();
                });
            }
            if (desc.clear) {
                desc.clear.call(hNode, props, sto, ctx);
            }
        }
        catch (err) {
            _console.error(err);
        }
    }
    else {
        if (props.ref) {
            props.ref();
        }
    }
    const index = expired.indexOf(hNode);
    if (~index) {
        expired.splice(index, 1);
    }
    if (hNode.out) {
        hNode.out.forEach((child) => {
            if (isHNode(child)) {
                clear(child);
            }
        });
    }
};

const updateChildren = function updChd(element, hNode, newChildren, oldChildren) {
    const { childNodes } = element, oldChildrenCount = oldChildren.length;
    let nodeOffset = 0, oldProps, oldNodes, newChild, newNodes, newProps, newPropKeys;
    oldChildren.forEach((oldChild, i) => {
        newChild = newChildren[i];
        if (newChild) {
            if (isHNode(oldChild)) {
                oldNodes = oldChild.nodes;
                if (isHNode(newChild) && newChild.type === oldChild.type) {
                    newNodes = oldNodes;
                    if (oldChild.desc) {
                        inherit(newChild, oldChild);
                        nodeOffset += newNodes.length;
                        return mark(newChild);
                    }
                    else {
                        newPropKeys = _keys(newProps = newChild.props);
                        if (_keys(oldProps = oldChild.props).every(key => newPropKeys.includes(key))) {
                            inherit(newChild, oldChild);
                            nodeOffset++;
                            return patch(newNodes[0], newChild, newProps, oldProps, newPropKeys);
                        }
                    }
                }
                clear(oldChild);
            }
            else if (HUI.cmp(oldChild, newChild)) {
                return nodeOffset++;
            }
            else {
                oldNodes = childNodes.length ? [childNodes[nodeOffset]] : [];
            }
            nodeOffset += (newNodes = toNodeArr(newChild, hNode.ctx, element, hNode)).length;
            if (oldNodes.length) {
                replaceNodes(element, oldNodes, newNodes);
            }
            else {
                element.appendChild(toFrag(newNodes));
            }
        }
        else {
            if (isHNode(oldChild)) {
                clear(oldChild);
                oldNodes = oldChild.nodes;
                oldChild.nodes.forEach(node => {
                    element.removeChild(node);
                });
                oldChild.nodes.length = 0;
            }
            else if (childNodes.length > nodeOffset) {
                element.removeChild(childNodes[nodeOffset++]);
            }
        }
    });
    if (oldChildrenCount < newChildren.length) {
        renderToDOM(newChildren.slice(oldChildrenCount), {
            parent: element,
            owner: hNode,
            context: hNode.ctx
        });
    }
};

const propHandlers = new _Map([
    ['children', function chdHandler(element, newChildren, oldChildren, hNode) {
            updateChildren(element, hNode, newChildren, oldChildren || []);
        }],
    ['style', function styHandler(element, style) {
            if (style && isObject(style)) {
                _assign(element.style, style);
            }
            else {
                try {
                    element.style = style;
                }
                catch {
                    element.setAttribute('style', style);
                }
            }
        }],
    ['class', function clsHandler(element, classes) {
            element.setAttribute('class', _isArray(classes) ?
                classes.filter(_Boolean).join(' ') :
                classes);
        }],
    ['ref', function refHandler(element, callback) {
            callback(element);
        }],
    ['attr', function attrHandler(element, attributes) {
            _entries(attributes).forEach(pair => {
                element.setAttribute(pair[0], pair[1]);
            });
        }],
    ['prop', function propHandler(element, properties) {
            _assign(element, properties);
        }]
]);

const listen = function (element, event, listener) {
    let capture = false, passive = true, once = false;
    for (let i = 0; i < 3; i++) {
        if (event.endsWith('Capture')) {
            capture = true;
            event = event.slice(0, -7);
        }
        else if (event.endsWith('Nonpassive')) {
            passive = false;
            event = event.slice(0, -10);
        }
        else if (event.endsWith('Once')) {
            once = true;
            event = event.slice(0, -4);
        }
    }
    const options = (capture || !passive || once) && { capture, passive, once };
    element.addEventListener(event, listener, options);
    return [event, listener, options];
};

const handleProp = function (element, hNode, key, newValue, oldValue) {
    const handler = propHandlers.get(key);
    if (handler) {
        handler(element, newValue, oldValue, hNode);
    }
    else {
        if (key.startsWith('on')) {
            const { evMap } = hNode, record = evMap.get(key);
            if (record) {
                element.removeEventListener(record[0], record[1], record[2]);
            }
            evMap.set(key, listen(element, key.slice(2), newValue));
        }
        else if (key in element) {
            try {
                element[key] = newValue;
            }
            catch {
                element.setAttribute(key, newValue);
            }
        }
        else {
            element.setAttribute(key, newValue);
        }
    }
};

const handleError = function handleErr(err, hNode) {
    let { owner } = hNode, desc;
    if (owner) {
        while (!((desc = owner.desc) && desc.catch) && owner.owner) {
            owner = owner.owner;
        }
        if (owner.desc) {
            owner.err = err;
            mark(owner);
            return;
        }
    }
    throw err;
};

const initComponent = function initCom(hNode, store) {
    const { props, ctx } = hNode, desc = hNode.desc, { defaultProps, defaultStore, storeHandlers, state, context, init, effects } = desc;
    if (defaultProps) {
        supply(props, defaultProps);
    }
    hNode.sto = store;
    if (defaultStore) {
        store.setSome(defaultStore);
    }
    if (state) {
        hNode.sto.bind(hNode, state);
    }
    if (storeHandlers) {
        store.handleSome(storeHandlers);
    }
    if (context) {
        ctx.bind(hNode, context);
    }
    if (init) {
        init.call(hNode, props, store, ctx);
    }
    if (effects) {
        hNode.eff = effects.map(effect => effect.call(hNode, props, store, ctx)).filter(_Boolean);
    }
};

const toNodeArr = function toNodes(src, context, ownerNode, owner) {
    const srcType = typeof src;
    if (srcType === 'string') {
        return [_createTextNode(src)];
    }
    else if (srcType === 'number') {
        return [_createTextNode(String(src))];
    }
    if (src) {
        if (_isArray(src) && src.length) {
            return src.flat(_Infinity).flatMap(s => toNodeArr(s, context, ownerNode, owner));
        }
        else if (isHNode(src)) {
            const { type, desc } = src;
            src.ownNode = ownerNode;
            src.owner = owner;
            src.ctx = context;
            if (desc) {
                const store = createStore();
                try {
                    src.active = false;
                    initComponent(src, store);
                    return src.nodes = toNodeArr(src.out = toArr(desc.render.call(src, src.props, store, context)).flat(_Infinity), context, ownerNode, src);
                }
                catch (err) {
                    if (desc.catch) {
                        return src.nodes = toNodeArr(src.out = toArr(desc.catch.call(src, err, src.props, store, context)).flat(_Infinity), context, ownerNode, src);
                    }
                    else {
                        handleError(err, src);
                    }
                }
                finally {
                    src.active = true;
                }
            }
            else {
                const { props } = src;
                src.evMap = new _Map();
                const element = props.xmlns ?
                    _document.createElementNS(props.xmlns, type) :
                    _document.createElement(type);
                _entries(props).forEach(pair => {
                    handleProp(element, src, pair[0], pair[1]);
                });
                src.out = [];
                src.nodes = [element];
                return [element];
            }
        }
    }
    return [_createTextNode('')];
};

const updateComponent = function updCom(hNode) {
    const { desc, out, nodes, owner, ownNode, ctx, props, sto, err } = hNode, outLength = out.length, ownerNodes = owner && owner.nodes;
    let newNodes = [].concat(nodes);
    try {
        hNode.active = false;
        if (err) {
            hNode.err = _undefined;
            throw err;
        }
        const ownerNodeNodes = ownNode.childNodes;
        let old, oldProps, oldNodes, oldNodesLength, curNodes, curProps, curPropKeys, nodeOffset = 0, nextNodeIndex, nextNode;
        const newOut = hNode.out = toArr(desc.render.call(hNode, props, sto, ctx)).flat(_Infinity), newOutLength = newOut.length;
        newOut.forEach((cur, i) => {
            if (i < outLength) {
                old = out[i];
                oldNodesLength = 1;
                if (isHNode(old)) {
                    oldNodesLength = (oldNodes = old.nodes).length;
                    clear(old);
                    if (isHNode(cur) && old.type === cur.type) {
                        if (old.desc) {
                            inherit(cur, old);
                            mark(cur);
                            return nodeOffset += oldNodesLength;
                        }
                        else {
                            curPropKeys = _keys(curProps = cur.props);
                            if (_keys(oldProps = old.props).every(k => curPropKeys.includes(k))) {
                                nodeOffset++;
                                inherit(cur, old);
                                return patch(oldNodes[0], cur, curProps, oldProps, curPropKeys);
                            }
                        }
                    }
                }
                else if (!isHNode(cur) && HUI.cmp(old, cur)) {
                    return nodeOffset++;
                }
                curNodes = toNodeArr(cur, ctx, ownNode, hNode);
                oldNodes = _splice.apply(newNodes, [newNodes.indexOf(nodes[nodeOffset]), oldNodesLength]
                    .concat(curNodes));
                nodeOffset += oldNodesLength;
                replaceNodes(ownNode, oldNodes, curNodes);
            }
            else {
                if (i === outLength) {
                    nextNodeIndex = _indexOf.call(ownerNodeNodes, newNodes[newNodes.length - 1]) + 1;
                    nextNode = ownerNodeNodes[nextNodeIndex] || _null;
                }
                _push.apply(newNodes, curNodes = toNodeArr(cur, ctx, ownNode, hNode));
                ownNode.insertBefore(toFrag(curNodes), nextNode);
            }
        });
        if (outLength > newOutLength) {
            out.slice(newOutLength).forEach(extra => {
                if (isHNode(extra)) {
                    clear(extra);
                }
            });
            newNodes.splice(nodeOffset).forEach(extraNode => {
                ownNode.removeChild(extraNode);
            });
        }
    }
    catch (err) {
        if (desc.catch) {
            newNodes = toNodeArr(hNode.out = toArr(desc.catch.call(hNode, err, props, sto, ctx)), ctx, ownNode, hNode);
            replaceNodes(ownNode, nodes, newNodes);
            out.forEach(child => {
                if (isHNode(child)) {
                    clear(child);
                }
            });
        }
        else {
            handleError(err, hNode);
        }
    }
    finally {
        hNode.active = true;
    }
    if (ownerNodes) {
        const firstNode = nodes[0], restArgs = [nodes.length].concat(newNodes);
        let target = owner, targetNodes = ownerNodes;
        while (target) {
            targetNodes = target.nodes;
            _splice.apply(targetNodes, [targetNodes.indexOf(firstNode)].concat(restArgs));
            target = target.owner;
        }
    }
    hNode.nodes = newNodes;
};

const expired = new Array();
const deferCallbacks = new Array();
let willTick = false;
const ticker = function frame() {
    willTick = false;
    const deadline = _now() + HUI.frameLimit;
    let cur, i;
    for (i = 0; i < expired.length; i++) {
        cur = expired[i];
        if (!cur) {
            continue;
        }
        expired[i] = _undefined;
        try {
            updateComponent(cur);
        }
        catch (err) {
            expired.splice(0, i + 1);
            throw err;
        }
        if (_now() >= deadline) {
            expired.splice(0, i + 1);
            return reqTick();
        }
    }
    expired.length = 0;
    for (i = 0; i < renderCallbacks.length; i++) {
        renderCallbacks[i]();
        if (_now() >= deadline) {
            renderCallbacks.splice(0, i + 1);
            return reqTick();
        }
    }
    renderCallbacks.length = 0;
    for (i = 0; i < deferCallbacks.length; i++) {
        deferCallbacks[i]();
        if (_now() >= deadline) {
            deferCallbacks.splice(0, i + 1);
            return reqTick();
        }
    }
    deferCallbacks.length = 0;
};
const reqTick = function () {
    HUI.tick(ticker);
    willTick = true;
};
const mark = function (hNode) {
    if (!expired.includes(hNode)) {
        expired.push(hNode);
        if (!willTick) {
            reqTick();
        }
    }
};
const defer = function (callback, ...args) {
    deferCallbacks.push(function () {
        callback.apply(_undefined, args);
    });
    if (!willTick) {
        reqTick();
    }
};

const createStore = function crtSto() {
    const valueMap = new _Map(), bindingMap = new _Map(), setterMap = new _Map(), handlerMap = new _Map();
    const store = {
        valueMap,
        bindingMap,
        setterMap,
        handlerMap,
        bind: function s_bind(hNode, subscriptions) {
            subscriptions.forEach(key => {
                if (bindingMap.has(key)) {
                    bindingMap.get(key).push(hNode);
                }
                else {
                    bindingMap.set(key, [hNode]);
                }
            });
            return this;
        },
        get: function s_get(key) {
            return valueMap.get(key);
        },
        set: function s_set(key, value, force) {
            if (force || !HUI.cmp(value, store.get(key))) {
                valueMap.set(key, value);
                if (bindingMap.has(key)) {
                    bindingMap.get(key).forEach(hNode => {
                        if (hNode.active) {
                            mark(hNode);
                        }
                    });
                }
            }
            return store;
        },
        setter: function s_setter(key, force) {
            const index = +!force;
            if (setterMap.has(key)) {
                const setters = setterMap.get(key), setter = setters[index];
                if (setter) {
                    return setter;
                }
                else {
                    return setters[index] = function setter(value) {
                        store.set(key, value, force);
                    };
                }
            }
            else {
                const setters = new Array();
                setterMap.set(key, setters);
                return setters[index] = function setter(value) {
                    store.set(key, value, force);
                };
            }
        },
        setSome: function s_setSome(pairs, force) {
            _entries(pairs).forEach(pair => {
                store.set(pair[0], pair[1], force);
            });
            return this;
        },
        toggle: function s_toggle(key) {
            return store.set(key, !store.get(key));
        },
        inc: function s_inc(key, addition = 1) {
            return store.set(key, store.get(key) + addition);
        },
        push: function s_push(key, ...items) {
            return store.set(key, store.get(key).concat(items));
        },
        unshift: function s_unshift(key, ...items) {
            return store.set(key, items.concat(store.get(key)));
        },
        slice: function s_slice(key, start, end) {
            return store.set(key, store.get(key).slice(start, end));
        },
        splice: function s_splice(key, start, deleteCount, ...items) {
            const arr = store.get(key).slice();
            _splice.apply(arr, [start, deleteCount].concat(items));
            return store.set(key, arr);
        },
        handle: function s_handle(name, handler) {
            if (handler) {
                handlerMap.set(name, handler.bind(store));
            }
            else {
                handlerMap.delete(name);
            }
            return this;
        },
        handleSome: function s_handleSome(handlers) {
            _entries(handlers).forEach(pair => {
                store.handle(pair[0], pair[1]);
            });
            return this;
        },
        getHandler: function s_getHandler(name) {
            return handlerMap.get(name);
        },
        trigger: function s_trigger(name, ...args) {
            const handler = handlerMap.get(name);
            if (handler) {
                return handler.apply(store, args);
            }
        }
    };
    return store;
};

const Fragment = define('HUI.Fragment', {
    render: function frag_render(props) {
        return props.children;
    }
});

const Portal = define('HUI.Portal', {
    storeHandlers: {
        c: function ptl_c(fragment) {
            const { ownNode, nodes } = fragment;
            if (nodes) {
                clear(fragment);
                nodes.forEach(node => {
                    ownNode.removeChild(node);
                });
                nodes.length = 0;
            }
        }
    },
    init: function ptl_init(props, store) {
        const { parent = _document.body } = props, fragment = HUI(Fragment, _null, props.children);
        store.set('p', parent);
        store.set('f', fragment);
    },
    render: function ptl_render(props, store, context) {
        const fragment = store.get('f');
        store.trigger('c', fragment);
        renderToDOM(fragment, {
            parent: store.get('p'),
            owner: this,
            context
        });
    },
    clear: function ptl_clr(props, store) {
        store.trigger('c', store.get('f'));
    }
});

const compare = function cmp(a, b) {
    if (_is(a, b)) {
        return true;
    }
    if (_isArray(a)) {
        return _isArray(b) &&
            a.length === b.length &&
            a.every((v, i) => compare(b[i], v));
    }
    if (a && b &&
        isObject(a) && isObject(b) &&
        _toString.call(a) === _toString.call(b)) {
        if (a[SYMBOL_ITERATOR]) {
            return b[SYMBOL_ITERATOR] &&
                compare(_from(a), _from(b));
        }
        else if (a.isHN) {
            return b.isHN &&
                a.type === b.type &&
                compare(a.props, b.props);
        }
        else if (!(a instanceof _Node || b instanceof _Node)) {
            const keysA = _keys(a), keysB = _keys(b);
            return keysA.length === keysB.length &&
                keysA.every(k => keysB.includes(k) && compare(a[k], b[k]));
        }
    }
    return false;
};

const HUI = (type, props, ...children) => ({
    isHN: true,
    type,
    desc: registry.get(type),
    props: _assign({ children: children.flat(_Infinity) }, props),
    active: true
});
HUI.registry = registry;
HUI.define = define;
HUI.createStore = createStore;
HUI.propHandlers = propHandlers;
HUI.noCmpProps = noCmpProps;
HUI.render = renderToDOM;
HUI.tick = function tick(callback) { _requestAnimationFrame(callback); };
HUI.frameLimit = 15;
HUI.defer = defer;
HUI.Portal = Portal;
HUI.Fragment = Fragment;
HUI.cmp = compare;

export default HUI;
