import { Store, StoreType, StoreHandlers, HandlerMap } from "./Store";
import { EleProps } from "./propHandlers";
import { EventMap } from "./events";
declare type ArrayWrapped<T> = T extends any[] ? T : [T];
export declare type HProps<P extends object = any> = {
    [K in keyof P]: K extends 'children' ? (P extends {
        children: any;
    } ? (ArrayWrapped<P['children']>) : (P extends {
        children?: any;
    } ? (ArrayWrapped<P['children']> | undefined) : (unknown[]))) : (P[K]);
} & ('children' extends keyof P ? {} : {
    children: unknown[];
});
export declare type HCallback<P extends object = any, S extends Store = Store, C extends Store = Store, T = unknown> = (this: HNode<P, S, C>, props: HProps<P>, store: S, context: C) => T;
export declare type EffectCallback<P extends object = any, S extends Store = Store, C extends Store = Store> = HCallback<P, S, C, (() => void) | void>;
export interface HDesc<P extends object = any, S extends Store = Store, C extends Store = Store> {
    defaultProps?: Partial<P>;
    defaultStore?: Partial<StoreType<S>>;
    storeHandlers?: Partial<HandlerMap<StoreType<S>, StoreHandlers<S>>>;
    effects?: EffectCallback<P, S, C>[];
    state?: Array<keyof StoreType<S>>;
    context?: Array<keyof StoreType<C>>;
    init?: HCallback<P, S, C, void>;
    render: HCallback<P, S, C, unknown>;
    clear?: HCallback<P, S, C, void>;
    catch?: (this: HNode<P, S, C>, err: any, props: HProps<P>, store: S, context: C) => unknown;
}
export interface HNode<P extends object = EleProps, S extends Store = Store, C extends Store = Store> {
    isHN: true;
    type: unknown;
    desc?: HDesc<P, S, C>;
    props: HProps<P>;
    sto?: S;
    ctx?: C;
    owner?: HNode<any>;
    ownNode?: Node;
    out?: unknown[];
    nodes?: Node[];
    active: boolean;
    evMap?: EventMap;
    eff?: (() => void)[];
    err?: unknown;
}
export declare const toNodeArr: (src: unknown, context: Store<any, any>, ownerNode: Node, owner?: HNode<any, Store<any, any>, Store<any, any>> | undefined) => Node[];
export {};
