import { HProps as _HProps, HDesc as _HDesc, HNode as _HNode, HCallback as _HCallback, EffectCallback as _EffectCallback } from "./HNode";
import { HType as _HType } from "./registry";
import { Store as _Store, HandlerMap as _HandlerMap, Setter as _Setter, SetterRecord as _SetterRecord, StoreHandlers as _StoreHandlers, EmptyStore as _EmptyStore } from "./Store";
import { RenderOptions as _RenderOptions } from "./render";
import { EleProps as _EleProps, PropHandler as _PropHandler, RefCallback as _RefCallback, AttributeMap as _AttributeMap } from "./propHandlers";
import { EventRecord as _EventRecord, EventMap as _EventMap } from "./events";
import { PortalProps as _PortalProps, PortalStore as _PortalStore } from "../ext/Portal";
import { FragmentProps as _FragmentProps } from "../ext/Fragment";
export declare const HUI: {
    <P extends object = _EleProps<Element>, S extends _Store<any, any> = _Store<any, any>, C extends _Store<any, any> = _Store<any, any>>(type: string | _HType<P, S, C>, props?: P | null | undefined, ...children: unknown[]): _HNode<P, S, C>;
    registry: Map<string | _HType<any, _Store<any, any>, _Store<any, any>>, _HDesc<any, _Store<any, any>, _Store<any, any>>>;
    define: <P extends object = any, S extends _Store<any, any> = _Store<any, any>, C extends _Store<any, any> = _Store<any, any>>(name: string, desc: _HDesc<P, S, C>) => _HType<P, S, C>;
    createStore: <T extends object = any, H extends object = any>() => _Store<T, H>;
    propHandlers: Map<string, _PropHandler<any>>;
    noCmpProps: string[];
    render: <C extends _Store<any, any> = _Store<any, any>>(src: any, options?: _RenderOptions<C>) => void;
    tick(callback: () => void): void;
    frameLimit: number;
    defer: <A extends any[] = any[]>(callback: import("../ticker/ticker").DeferCallback<A>, ...args: A) => void;
    Portal: _HType<_PortalProps, _Store<{
        p: Node;
        f: _HNode<_FragmentProps, _Store<{}, {}>, _Store<{}, {}>>;
    }, {
        c: (frag: _HNode<_FragmentProps, _Store<{}, {}>, _Store<{}, {}>>) => void;
    }>, _Store<{}, {}>>;
    Fragment: _HType<_FragmentProps, _Store<{}, {}>, _Store<{}, {}>>;
    cmp: (a: unknown, b: unknown) => boolean;
};
export declare namespace HUI {
    type HProps<P extends object = any> = _HProps<P>;
    type HCallback<P extends object = any, S extends _Store = _Store, C extends _Store = _Store, T = unknown> = _HCallback<P, S, C, T>;
    type EffectCallback<P extends object = any, S extends _Store = _Store, C extends _Store = _Store> = _EffectCallback<P, S, C>;
    type HDesc<P extends object = any, S extends _Store = _Store, C extends _Store = _Store> = _HDesc<P, S, C>;
    type HNode<P extends object = any, S extends _Store = _Store, C extends _Store = _Store> = _HNode<P, S, C>;
    type HType<P extends object = any, S extends _Store = _Store, C extends _Store = _Store> = _HType<P, S, C>;
    type Store<T extends object = any, H extends object = any> = _Store<T, H>;
    type StoreHandlers<S extends _Store = _Store> = _StoreHandlers<S>;
    type HandlerMap<T extends object = any, H extends object = any> = _HandlerMap<T, H>;
    type Setter<T = unknown> = _Setter<T>;
    type SetterRecord<T = unknown> = _SetterRecord<T>;
    type EmptyStore = _EmptyStore;
    type RenderOptions<C extends Store = Store> = _RenderOptions<C>;
    type EleProps<T extends Element = Element> = _EleProps<T>;
    type PropHandler<T = unknown> = _PropHandler<T>;
    type RefCallback<T extends Element = Element> = _RefCallback<T>;
    type AttributeMap = _AttributeMap;
    type EventRecord = _EventRecord;
    type EventMap = _EventMap;
    type FragmentProps = _FragmentProps;
    type PortalProps = _PortalProps;
    type PortalStore = _PortalStore;
}
